/**
 * Die Klasse Tram definiert Straenbahnen und stellt verschiedene
 * Methoden bereit um auf Tram-Objekten zu arbeiten
 * 
 * @author (Tobias Hennchen) 
 * @version (2007.05.22)
 */


public class Tram {
    
    //@param driveMode Wahr, falls Tram fhrt
    boolean driveMode;

    //Liniennummer der Tram
    int line;

    //Anzahl Passagiere in Tram
    int passenger;

    /**
     * Konstruktor zur Initialisierung einer Tram
     *
     * @param line Liniennummer
     */
    Tram(int line) {

        this.line = line;

        driveMode = false;
        passenger = 0;

        System.out.println("Linie " + line + ": Betriebsbereit");
    }

    /**
     * Tram in Fahrmodus setzen.
     */
    void drive() {
        driveMode = true;
        System.out.println("Linie " + line + ": Faehrt");
    }

    /**
     * Tram anhalten.
     */
    void halt() {
        driveMode = false;
        System.out.println("Linie " + line + ": Haelt.");
    }

    /**
     * Lasse Passagiere einsteigen.
     *
     * @param n Anzahl Passagiere
     */
    void getIn(int n) {
        if(driveMode) {
            System.out.println("Linie " + line + ": Einsteigen nicht moeglich. Bahn faehrt.");
        } else {
            passenger += n;
            System.out.println("Linie " + line + ": Es sind " +  n + " Passagiere eingestiegen.");
        }
    }

    /**
     * Lasse Passagiere aussteigen.
     *
     * @param n Anzahl Passagiere
     */
    void getOut(int n) {
        if(driveMode) {
            System.out.println("Linie " + line + ": Aussteigen nicht moeglich. Bahn faehrt.");
        } else {
            if (n >= passenger) {
                System.out.println("Linie " + line + ": Soviele Passagiere sind nicht in der Bahn. Vorgang abgebrochen.");
            } else {
                passenger -= n;
                System.out.println("Linie " + line + ": Es sind " +  n + " Passagiere ausgestiegen.");
            }
        }

    }


}